﻿using UnityEngine;
using System.Collections;

public class Clock : MonoBehaviour {
	
	public GUISkin skin;
	
	float pauseTimeLeft = 0.5f;
	public float timeLeft = 10f;
	public float timeDialation = 1f;

	GameObject player;
	
	void Start() {
		player = GameObject.Find("Player");
	}

	void Update () {
		if(player != null) {
			
			if(pauseTimeLeft > 0) {
				pauseTimeLeft -= Time.deltaTime;
			}
			else {
				timeLeft -= Time.deltaTime;
			}
			
			Time.timeScale = Mathf.Lerp(Time.timeScale, 1f, 2f);
			
		}
		
		if(timeLeft < 0) {
			if(player != null) {
				player.GetComponent<Health>().Die();
			}
		}
		
		if(player == null && Input.GetKeyDown("space")) {
			Application.LoadLevel(Application.loadedLevel);
		}
	}
	
	void OnGUI() {
		if(timeLeft > 0) {
			GUI.skin = skin;
			GUILayout.BeginArea( new Rect(0,0, Screen.width, Screen.height) );
			GUILayout.BeginVertical();
			GUILayout.BeginHorizontal();
			GUILayout.Label("Time Remaining: " + timeLeft.ToString("0.00") );
			GUILayout.EndHorizontal();
			GUILayout.FlexibleSpace();
			GUILayout.EndVertical();
			GUILayout.EndArea();
		}
		
		
		if( timeLeft <= 0 ) {
			GUI.skin = skin;
			GUILayout.BeginArea( new Rect(0,0, Screen.width, Screen.height) );
			GUILayout.FlexibleSpace();
			GUILayout.BeginVertical();
			GUILayout.BeginHorizontal();
			GUILayout.BeginVertical();
			GUILayout.Label("Time's up!");
			GUILayout.Label("<space> to restart");
			GUILayout.EndVertical();
			GUILayout.EndHorizontal();
			GUILayout.FlexibleSpace();
			GUILayout.EndVertical();
			GUILayout.EndArea();
		}
		else if(player == null) {
			GUI.skin = skin;
			GUILayout.BeginArea( new Rect(0,0, Screen.width, Screen.height) );
			GUILayout.FlexibleSpace();
			GUILayout.BeginVertical();
			GUILayout.BeginHorizontal();
			GUILayout.BeginVertical();
			GUILayout.Label("Access denied!");
			GUILayout.Label("<space> to restart");
			GUILayout.EndVertical();
			GUILayout.EndHorizontal();
			GUILayout.FlexibleSpace();
			GUILayout.EndVertical();
			GUILayout.EndArea();
		}
	}
	
	public void AddTime(float t) {
		if(player != null) {
			//timeLeft += t;
			pauseTimeLeft = 5f;
		}
		//Time.timeScale *= 0.1f;
	}
}
