﻿using UnityEngine;
using System.Collections.Generic;

public class Lane : MonoBehaviour {
	
	public GameObject nodeGoodPrefab;
	public GameObject nodeBadPrefab;
	public GameObject moreTimePrefab;
	
	static int clockCount = 5;
	
	List<GameObject> nodes;
	int maxNodes = 11;
	float maxX = 10f;
	
	float moreTimeChance = 0.1f;
	
	public float speed = 0f;
	public float badChance = 0f;
	
	// Use this for initialization
	void Start () {

				nodes = new List<GameObject>();
		
		for(int i=0; i < maxNodes; i++) {
			SpawnCube();
		}
		
		//if(moreTimePrefab != null && Random.Range(0, 1f) < moreTimeChance) {
		clockCount--;
		if(clockCount <= 0) {
			Vector3 pos = new Vector3(Random.Range(1f, 9f), transform.position.y, transform.position.z);
			Instantiate(moreTimePrefab, pos, Quaternion.identity);
			clockCount = Random.Range(4, 6);
		}		
	}
	
	// Update is called once per frame
	void Update () {
		for(int i=0; i < nodes.Count; i++) {
			GameObject n = nodes[i];
			n.transform.Translate(speed * Time.deltaTime, 0, 0);
			if(
				 (speed >= 0 && n.transform.position.x > maxX) ||
				 (speed < 0 && n.transform.position.x < -1f)
				) {
				nodes.Remove(n);
				Destroy(n);
				i--;
			}
		}
		
		while(nodes.Count < maxNodes) {
			SpawnCube();
		}
	}
	
	void SpawnCube() {
		float offset = (speed >= 0 ? maxX : -1);
		
		if(nodes.Count > 0) {
			GameObject last = nodes[nodes.Count-1];
			offset = last.transform.position.x - (speed >= 0 ? 1 : -1);
		}
		
		Vector3 pos = new Vector3(offset, transform.position.y, transform.position.z);
		GameObject n = (GameObject)Instantiate( Random.Range(0f, 1f) > badChance ? nodeGoodPrefab: nodeBadPrefab, pos, Quaternion.identity);
		n.transform.parent = transform;
		nodes.Add(n);
		
	}
}
