﻿using UnityEngine;
using System.Collections;

public class LevelBox : MonoBehaviour {
	
	public GameObject laneSafe;
	public GameObject laneMoving;
	float laneSpeedFactor = 0.01f; 
	int lanesAhead = 15;
	int numLanes = 0;
	
	public GameObject mesh;
	
	Transform playerTransform;
	
	// Use this for initialization
	void Start () {
		playerTransform = GameObject.Find("Player").transform;
	}
	
	void AddLane() {
		
		Vector3 pos;
		
		// Add the level box
		GameObject m = (GameObject)Instantiate(mesh);
		m.transform.parent = transform;
		pos = Vector3.forward * numLanes;
		m.transform.localPosition = pos;
		
		// Add the moving lane
		GameObject l = (GameObject)Instantiate(numLanes%2==1 ? laneMoving : laneSafe);
		l.transform.parent = transform;
		pos = Vector3.forward * numLanes;
		l.transform.localPosition = pos;
		
		Lane lControl = l.GetComponent<Lane>();
		lControl.speed += (laneSpeedFactor * numLanes);
		if(Random.Range(0,2)==0) {
			lControl.speed *= -1;
		}
		
		numLanes++;
	}
	
	// Update is called once per frame
	void Update () {
		while(playerTransform != null && playerTransform.position.z + lanesAhead > numLanes) {
			AddLane();
		}
	}
}
