﻿using UnityEngine;
using System.Collections;

public class Score : MonoBehaviour {
	public GUISkin skin;
	float maxZ = 0;
	
	int highScore;
	int score=0;
	
	public void UpdateZ(float z) {
		if( z > maxZ ) {
			maxZ = z;
			score = Mathf.FloorToInt(maxZ * 100);
			if(score >= highScore) {
				highScore = score;
			}
		}
	}
	
	Transform playerTransform;
	
	void Start() {
		playerTransform = GameObject.Find("Player").transform;
		
		highScore = PlayerPrefs.GetInt("highScore", 0);
	}
	
	void OnDestroy() {
		PlayerPrefs.SetInt("highScore", highScore);
	}
	
	void Update() {
		if(playerTransform != null) {
			UpdateZ(playerTransform.position.z);
		}
	}

	void OnGUI() {
		GUI.skin = skin;
		GUILayout.BeginArea( new Rect(0,0, Screen.width, Screen.height) );
		GUILayout.FlexibleSpace();
		GUILayout.BeginVertical();
		GUILayout.BeginHorizontal();
		GUILayout.FlexibleSpace();
		GUILayout.Label("Score: " + (score).ToString("0") );
		GUILayout.Label("(High: " + (highScore).ToString("0") + ")" );
		GUILayout.FlexibleSpace();
		GUILayout.EndHorizontal();
		GUILayout.EndVertical();
		GUILayout.EndArea();
	}
	
}
